Design Gurus Logo
Solution: Coin Change
Go Back

Introduction

Given an infinite supply of ‘n’ coin denominations and a total money amount, we are asked to find the total number of distinct ways to make up that amount.

Example:

Denominations: {1,2,3}
Total amount: 5
Output: 5
Explanation: There are five ways to make the change for '5', here are those ways:
  1. {1,1,1,1,1} 
  2. {1,1,1,2} 
  3. {1,2,2}
  4. {1,1,3}
  5. {2,3}

Problem Statement

Given a number array to represent different coin denominations and a total amount 'T', we need to find all the different ways to make a change for 'T' with the given coin denominations. We can assume an infinite supply of coins, therefore, each coin can be chosen multiple times.

Constraints:

  • 1 <= coins.length <= 12
  • 1 <= coins[i] <= 2<sup>31</sup> - 1
  • 0 <= amount <= 10<sup>4</sup>

This problem follows the "Unbounded Knapsack" pattern.

Basic Solution

A basic brute-force solution could be to try all combinations of the given coins to select the ones that give a total sum of 'T'. This is what our algorithm will look like:

for each coin 'c' create a new set which includes one quantity of coin 'c' if it does not exceed 'T', and recursively call to process all coins create a new set without coin 'c', and recursively call to process the remaining coins return the count of sets who have a sum equal to 'T'

This problem is quite similar to "Count of Subset Sum". The only difference here is that after including the item (i.e., coin), we recursively call to process all the items (including the current coin). In 'Count of Subset Sum', however, we were recursively calling to process only the remaining items.

Code

Here is the code for the brute-force solution:

Python3
Python3

The time complexity of the above algorithm is exponential O(2^{C+T}), where 'C' represents total coin denominations and 'T' is the total amount that we want to make change. The space complexity will be O(C+T).

Let's try to find a better solution.

Top-down Dynamic Programming with Memoization

We can use memoization to overcome the overlapping sub-problems. We will be using a two-dimensional array to store the results of solved sub-problems. As mentioned above, we need to store results for every coin combination and for every possible sum:

Python3
Python3

Bottom-up Dynamic Programming

We will try to find if we can make all possible sums, with every combination of coins, to populate the array dp[TotalDenominations][Total+1].

So for every possible total ‘t’ (0<= t <= Total) and for every possible coin index (0 <= index < denominations.length), we have two options:

  1. Exclude the coin. Count all the coin combinations without the given coin up to the total 't' => dp[index-1][t]
  2. Include the coin if its value is not more than ‘t’. In this case, we will count all the coin combinations to get the remaining total: dp[index][t-denominations[index]]

Finally, to find the total combinations, we will add both the above two values:

dp[index][t] = dp[index-1][t] + dp[index][t-denominations[index]]

Let’s draw this visually with the following example:

    Denominations: [1, 2, 3]  
    Total: 5 

Let’s start with our base case of zero total:

Image
'0' total can always be found through an empty set
Image
total: 1, index:0=> dp[index][total - denominations[index]], since index =0, we didn't consider dp[index-1][total]
Image
total: 2-5, index:0=> dp[index][total - denominations[index]], since index =0, we didn't consider dp[index-1][total]
Image
total: 1, index:1=> dp[index-1][total] , we didn't consider dp[index][total - denominations[index]], since 'total < denominations[index]'
Image
total: 2, index:1=> dp[index-1][total] + dp[index][total - denominations[index]]
Image
total: 3, index:1=> dp[index-1][total] + dp[index][total - denominations[index]]
Image
total: 4, index:1=> dp[index-1][total] + dp[index][total - denominations[index]]
Image
total: 5, index:1=> dp[index-1][total] + dp[index][total - denominations[index]]
Image
total: 5, index:2=> dp[index-1][total] + dp[index][total - denominations[index]]

Code

Here is the code for our bottom-up dynamic programming approach:

Python3
Python3

The above solution has time and space complexity of O(C*T), where 'C' represents total coin denominations and 'T' is the total amount that we want to make change.